/* Implementation of Edinburgh Compatible Context Editor
   in LC for Intel 8086 by Rainer Thonnes, December 1980
   based on that in IMP for DEC PDP9/15 by Hamish Dewar,
   June 1970 */

// Only one known current *coding* bug:  typing the 'y' macro command before it is
// defined causes the program to hang.  Probably in an infinite loop.

// known compiler bug: %s causes an error


static instream = 0, outstream = 0

static infile
static secondary
static outfile

static min=1
static sin=2
static stop=-5000
static inp=min
static mon=0
static casebit=95
static print1=0
static print2=0
static sextra=1122     // originally 122
static pp1
static sym
static code
static text
static num
static cbase=1
static tbase=120
static ci
static ti
static cmax=0
array c[121]           // cbase:tbase
array stored[193]      // 1:192
static pos1=0
static pos2=0
static pos3=0
static bufmax=510000   // was 10000
static top=1
static bot=bufmax-sextra   // 509878      // was bufmax-sextra
array a[510001]        // was 0:bufmax
static lbeg
static pp
static fp=0
static lend=0
static fend=0
static ms=0
static ml=0
static type
static chain
static pend=0
static mfp=0
static mlend=0
static mend=0
static sfp=0
static send=0
const array symtype[96] =    // was 33:95
   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0
   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0

   0  64   3   3   3   2   3   3  11   9  64   3  12   2   3   3
   0   0   0   0   0   0   0   0   0   0   3   1   3   3   3  64
   3  18  10  26   5   8  52  10   2   6  10  10 122  56   2   2
  10  50  10  22   5 117   6   2  32  32  32   3  10   3   3   3;

/*    !   "   #   $   %   &   '   (   )   *   +   ,   -   .   /
  0   1   2   3   4   5   6   7   8   9   :   ;   <   =   >   ?
  @   A   B   C   D   E   F   G   H   I   J   K   L   M   N   O
  P   Q   R   S   T   U   V   W   X   Y   Z   [   \   ]   ^   _

Special classes

0 Normal
1 %A,%C,%S
2 %X,%Y,%Z
3 %M,%F,%Q
4 ! * ?
5 unused
6 unused
7 %L,%U

Normal classes

0 Digits 0:9
1 NL and ;
2 Illegals %,-,A,H,N,O,Q,W
3 delimiters "#$&'+./<>=@[]^_
4 F
5 D,T,U
6 I,S,V
7 unused
8 E,M
9 )
10 B,C,G,J,K,L,P,R,\
11 (
12 ,
13 unused
14 unused
15 unused */

static i
static j
static k
static nl=10
static last_sym = nl

proc printnum(d)
  if d < 0
    putchar('-')
    d = 0-d                          // try d = -d when supported
  finish
  printnum(d/10) if d >= 10
  putchar(d - (d / 10) * 10 + '0')   // try d % 10 when supported
end

proc dosignal (i1 j1 k2)
  exit (0) if i1 = 0;

  if i1 = 14; if j1 = 2
      print "Missing switch label: "
      printnum(k2); putchar(10);
      exit (1)
  finish;finish

  print "Unhandled signal "
  printnum(i1); putchar(','); printnum(j1); putchar(','); printnum(k2); putchar(10);
  exit (1)
end

// file input: stream = min or sin (1 or 2)
proc fileget (stream)
  return -1;
//  if stream = min
//    return fgetc(infile)
//  else
//    return fgetc(secondary)
//  finish
end

// file output
proc putsym (c3)
  //  fputc (c3, outfile)
end

proc readsym()
  if pend<>0
    sym=pend; pend=0
  else
    cycle
      if pos3=0
        if last_sym = nl
          putchar('>'); putchar('>') if inp=sin
        finish
        sym=getchar(); last_sym = sym; return
      finish
      sym=stored[pos3]; pos3=pos3+1
      return if sym<>0
      pos3=pos2; pos2=pos1; pos1=0
    repeat
  finish
end

proc readitem()
  cycle
    type=1
    cycle
      readsym(); return -1 if sym < 0;
    repeat if sym=' '
    return 0 if sym<' '
    sym=sym-32 if sym>=96
    type=symtype[sym]
    return 0 if type&15<>0
    if type=32
      pos1=pos2; pos2=pos3; pos3=((sym-'X')<<6)+1
    finish
  repeat if type=32
  if type=0
    num=sym-'0'
    cycle
      readsym(); return 0 if sym < 0; pend=sym
      return 0 if sym<'0'
      return 0 if sym>'9'
      pend=0; num=num*10-'0'+sym
    repeat
  else
    type=0; num=0; return 0 if sym='*'
    num=stop+1;    return 0 if sym='?'
    num=stop                /* sym='!' */
  finish
  return 0
end

proc unchain()
  cycle
    text=chain; return if text=0
    chain=c[text+1]; c[text+1]=ci
  repeat if c[text]<>'('
end

proc stack(v)
  c[ci]=v; ci=ci+1
end

proc readline()
static readline_k
  if fp<>fend
    lend=fp
    cycle
      return if a[lend]=nl
      lend=lend+1
    repeat
  finish
  fp=bot-1121
  cycle
    readline_k=nl;
    readline_k=fileget(inp) if fp<>bot;
    if readline_k < 0
      fp=bot; lend=fp; fend=lend; a[fp]=nl
      jump rt
    finish
    a[fp]=readline_k; fp=fp+1
  repeat if readline_k<>nl
  fend=fp; lend=fend-1; fp=bot-1121
rt: ms=0; print1=0; print2=0
end

proc breakline()
  a[pp]=nl; pp=pp+1; lbeg=pp
end

proc leftstar()
  cycle
    return if pp=lbeg
    fp=fp-1; pp=pp-1; a[fp]=a[pp]
  repeat
end

proc rightstar()
  cycle
    return if fp=lend
    a[pp]=a[fp]; pp=pp+1; fp=fp+1
  repeat
end

proc makespace()
static makespace_k
static p1
static p2

  if inp=min
    p1 = fp 
  else
    p1 = mfp
  finish
  return if p1-pp>240

  p1=top; p2=(p1+lbeg)>>1; p2=lbeg if code='C'
  dosignal(15, p1, p2) if p2=top
  cycle
    makespace_k=a[p1]; putsym(makespace_k); p1=p1+1
    makespace_k=0 if p1<p2
  repeat if makespace_k<>nl
  lbeg=top+lbeg-p1; p2=pp; pp=top
  cycle
    return if p1=p2
    a[pp]=a[p1]; pp=pp+1; p1=p1+1
  repeat
end

proc refresh()
  fp=fp+1; makespace(); readline()
end

proc printline()
static p
  print1=lend; print2=fp+pp; p=lbeg
  cycle
    if p=pp;
      if p<>lbeg;
        putchar('^') if num=0
      finish
      p=fp
    finish
    if p=lend;
      if p=fend;
        print "**End**"
      finish
      putchar(nl); return
    finish
    putchar(a[p]); p=p+1
  repeat
end

proc cased(ch)
  return ch if ch<'a'
  return ch if ch>'z'
  return ch&casebit
end

proc matched()   // used for F,U,T,D,V
static matched_i
static matched_j
static matched_k
static l
static t1
static fp1
static lim
  lim=c[ci-3]>>7
  t1=cased(c[text])
  cycle
    pp1=pp; fp1=fp;
    if fp<>lend; cycle                // convert to while loop when supported
      matched_k=a[fp];
      if cased(matched_k)=t1;
        if fp=ms;
          jump nope if code='F'
          jump nope if code='U'
        finish
        matched_i=fp; matched_j=text
        cycle
          matched_i=matched_i+1; matched_j=matched_j-1; l=cased(c[matched_j]);
          if l=0;
            ms=fp; ml=matched_i; return 1
          finish
        repeat if cased(a[matched_i])=l
      finish
      return 0 if code='V'
nope:a[pp]=matched_k; pp=pp+1; fp=fp+1
    repeat if fp<>lend; finish        // end of while loop
    return 0 if code='V'
    lim=lim-1; lim=0 if fp=fend;
    if lim=0;
      pp=pp1; fp=fp1; return 0
    finish;
    if code='U';
      pp=pp1
    else
      breakline()
    finish
    refresh()
  repeat
end

proc switchinputs()
  if inp=min
    leftstar(); inp=sin
    mfp=fp; mlend=lend; mend=fend
    bot=bot+sextra; fp=sfp; fend=send
    readline()
  else
    pp=lbeg; inp=min
    bot=bot-sextra; sfp=fp; send=fend; fp=mfp
    lend=mlend; fend=mend
  finish
end

  print "ECCE 06/01/81"
  putchar(nl)

  pp=top-1; breakline(); readline()
readco:
  cycle
    ci=cbase; ti=tbase; chain=0
    jump eof if readitem()<0;
  repeat if type=1;
  if type=0; if cmax<>0;
    c[cmax+2]=num; jump eof if readitem()<0;
    jump er2 if type<>1;
    jump execute
  finish; finish;
  if sym='%';
    readsym(); jump eof if sym < 0; sym=sym-32 if sym>=96; code=sym
    jump er5 if code<'A'; jump eof if readitem()<0;
    i=symtype[code]>>4
  else
nextunit:
    i=type&15; jump er2 if i<4;
    code=sym; text=0; num=1; jump eof if readitem()<0;
  finish
  jump er5 if i=0;
  if i=1;  // %c,s,a
    return if code='A';
    if code='S';
      switchinputs(); jump monitor
    finish
eof:code='C';
    switchinputs() if inp=sin;
    cycle
      rightstar();
      if fp=fend;
        cycle
          return if top=pp;
          putsym(a[top]); top=top+1
        repeat
      finish
      breakline(); refresh()
    repeat
  finish;
  if i=2;  // %x,y,z
    i=((code-'X')<<6)+1;
    if sym='=';
      cycle
        readsym(); jump eof if sym < 0;
        if sym<>nl;
          stored[i]=sym;
          jump er6 if i&63=0;
          i=i+1
        finish
      repeat if sym<>nl;
      stored[i]=0
      jump readco
    finish
    cycle
      sym=stored[i];
      if sym=0;
        putchar(nl); jump readco;
      finish
      putchar(sym); i=i+1
    repeat
  finish;
  if i=3;  // %m,f,q
    mon='M'-code; jump readco
  finish;
  if i=4;  // f
    num=0 if type<>0;
  finish;
  if i<=5;  // +d,t,u
    code=(num<<7)+code; num=1;
    if type=0;
      jump eof if readitem()<0;
    finish
  finish;
  if i<=6;  // +i,s,v
    jump er4 if type<>3; text=ti; i=sym
    cycle
      readsym(); jump eof if sym < 0;
      if sym=nl;
        pend=sym; i=sym
      finish
      if sym=i;
        if code<>'I'; if code<>'S'
          jump er4 if sym=nl;
          jump er4 if ti=text
        finish; finish
        c[ti]=0; ti=ti-1; jump ri
      finish
      jump er6 if ti<=ci; c[ti]=sym; ti=ti-1
    repeat
  finish;
  if i=7;  // %u,l
    casebit=95; casebit=127 if code='L'; jump readco
  finish;
  if i=8;  // m,e
    jump nq if sym<>'-'; code=code+10
ri: jump eof if readitem()<0; jump rn
  finish;
  if i=9;  // )
    unchain(); jump er3 if text=0;
    c[text+2]=num; text=text+3
  finish;
  if i<=10;  // +g,k,etc
nq: jump er1 if type=3;
rn: if type=0;
      jump eof if readitem()<0;
    finish
    jump put
  finish
  if i=12;  // ,
    if type=1;
      jump eof if readitem()<0
    finish
  finish;
  if i<=12;  // +(
    text=chain; chain=ci; num=0
  finish;
  dosignal(14, 1, i) if i>12;
put: stack(code); stack(text); stack(num)
  jump er6 if ci+4>=ti
  jump nextunit if type<>1
  unchain(); jump er3 if text<>0
  cmax=ci
  stack(')'); stack(cbase); stack(1)
  stack(0); jump execute
er1: putchar(' '); putchar(code)
er2: code=sym; jump er5
er3: print " ()"; jump er7
er4: print " Text for"
er5: putchar(' '); putchar(code&127); jump er7
er6: print " Size"
er7: putchar('?'); putchar(nl);
  cmax=0 if ci<>cbase;
  cycle
    jump readco if sym=nl; readsym(); jump eof if sym < 0;
  repeat
execute:
  ci=cbase
get: code=c[ci]&127; jump monitor if code=0;
  text=c[ci+1]; num=c[ci+2]; ci=ci+3
rpt: num=num-1
  jump xm if code='M'
  jump xw if code='W'
  jump xl if code='L'
  jump xr if code='R'
  jump xc if code='C'
  jump xlb if code='('
  jump xcomma if code=','
  jump xrb if code=')'
  jump no if code='\\'
  jump xj if code='J'
  jump xk if code='K'
  jump xp if code='P'
  jump xb if code='B'
  jump xg if code='G'
  jump xi if code='I'
  jump xs if code='S'
  jump xt if code='T'
  jump xd if code='D'
  jump xu if code='U'
  jump xf if code='F'
  jump xv if code='V'
  jump xo if code='O'
  jump xe if code='E'
  dosignal(14, 2, code)
ok: jump get if num=0
    jump get if num=stop
    jump rpt
no: jump get if num<0;
  if c[ci]='\\';
    ci=ci+3; jump get
  finish
skp: i=c[ci]; ci=c[ci+1] if i='('; ci=ci+3;
  if i<>','; if i<>')';
    jump skp if i<>0; jump xer
  finish; finish
  num=c[ci-1]-1; jump no
xer: print "Failure: ";
  if code='O'
    putchar('E'); code='-'
  else if code='W';
    putchar('M'); code='-'
  finish
  putchar(code);
  if text<>0;
    putchar('"')
    cycle
      i=c[text]; putchar(i) if i<>0; text=text-1
    repeat if i<>0
    putchar('"')
  finish
  putchar(nl); print1=0
monitor:
  jump readco if sym<>nl
  jump readco if mon<0
  if print1=lend
    jump readco if mon=0
    jump readco if print2=fp+pp
  finish
  num=0; printline()
  jump readco
xlb: c[text+2]=num+1; jump get
xrb: jump get if num=0
     jump get if num=stop
     c[ci-1]=num
xcomma: ci=text; jump get
xc: jump no if fp=lend; i=a[fp];
    if i&95>='A'; if i&95<='Z';
      if i&32 <> 0;
        a[fp]=i-32
      else
        a[fp]=i+32
      finish
    finish; finish
xr: jump no if fp=lend
    a[pp]=a[fp]; pp=pp+1; fp=fp+1; jump ok
xl: jump no if pp=lbeg
    jump no if inp=sin
    fp=fp-1; pp=pp-1; a[fp]=a[pp]
    ms=0; jump ok
xe: jump no if fp=lend; fp=fp+1; jump ok
xo: jump no if pp=lbeg; pp=pp-1; jump ok
xv:xu:xd:xf:    jump no if matched()=0;
    if code='U';
      pp=pp1;
    else if code='D';
      fp=ml
    finish
    jump ok
xt: jump no if matched()=0
    cycle
      a[pp]=a[fp]; pp=pp+1; fp=fp+1
    repeat if fp<>ml
    jump ok
xs: jump no if fp<>ms; fp=ml
xi: makespace()
    jump no if pp-lbeg+lend-fp>80;
    i=text
    cycle
      jump ok if c[i]=0
      a[pp]=c[i]; pp=pp+1; i=i-1
    repeat
xg: putchar(':')
    makespace(); i=getchar(); last_sym = i; jump eof if i<0; jump no if i=':'; leftstar();
    if i<>nl; cycle                 // convert to while loop when supported
      a[pp]=i; pp=pp+1; i=getchar(); last_sym = i; jump eof if i<0;
    repeat if i<>nl; finish         // end of while loop
xb: breakline(); jump ok
xp: printline(); jump get if num=0;
xm: rightstar(); jump no if fp=fend; breakline()
m1: refresh(); jump ok
xk: pp=lbeg; fp=lend
k1: jump no if fp=fend; jump m1
xj: rightstar(); jump no if pp-lbeg>80; jump k1
xw: jump no if inp=sin
    makespace()
    jump no if lbeg=top
    lend=fp-pp+lbeg-1
    cycle
      k=a[pp-1];
      if k=nl; if pp<>lbeg;
        lbeg=pp; ms=0; jump ok
      finish; finish
      fp=fp-1; pp=pp-1; a[fp]=k
    repeat
